-- QuickerTornados by DarthPresidente

-- Increases the speed the tornado moves but reduces it's time on the island
-- 		By Default:	Speed is increased 4 times
--					Duration is reduced to a third

local TornadoSpeed = 160
local TornadoMaxPresenceTime = 2 * MonthLength
local TornadoMinPresenceTime = 2 * MonthLength


function QuickTornado()
	g_Classes.Tornado.speed = TornadoSpeed
	g_Classes.Tornado.passed_buildings = false
	Tornado.Move = function(self)
		local start_time = GameTime()
		self:PushDestructor(function()
			self:Cleanup()
		end
		)
		self:StartGrab()
		self.active = true
		self:ChooseNextVictim()
		while self.active and GameTime() - start_time < TornadoMaxPresenceTime do
			self:DamageArea()
			self:AffectCitizens()
			self:MoveStep()
		end
		self.active = false
		local wander_pos, wander_time = nil, nil
		while GameTime() - start_time < TornadoMinPresenceTime do
			local wander_pos = self:GetSpawnPos(self:GetPos(), 200 * guim)
			local wander_time = self:GetPos():Dist(wander_pos) / self.speed * guim
			self:SetPos(wander_pos:SetInvalidZ(), wander_time)
			Sleep(wander_time)
		end
		local disappear_pos = self:GetSpawnPos(self:GetPos(), 200 * guim)
		self:SetPos(disappear_pos:SetInvalidZ(), self:GetPos():Dist(disappear_pos) / self.speed * guim)
		self:StopGrab()
		self:PopDestructor()
		self:SetCommand("Disappear")
	end
end


local FiredOnce = false
OnMsg.UASetMode = function(actions,mode)
    if not FiredOnce then
        if(mode == "Boot") then
            FiredOnce = true
            CreateRealTimeThread(function()
                QuickTornado()
                OnMsg.MapPermanentObjectsLoaded = function()
                    QuickTornado()
                end
            end)
        end
    end
end